import tkinter
from tkinter import *
from tkinter import ttk

import pandas as pd
from PIL import Image, ImageTk

from plot import Scatter, Require_graph, Network_graph


class Menu:
    """main menu of this application """

    def __init__(self, root):
        self.root = root
        data_file = Read_file("best cities for a workation.csv")
        self.data = data_file.read()

        # Background image
        self.image1 = Image.open("imagemenu.png")
        self.photo = ImageTk.PhotoImage(self.image1)
        self.background = tkinter.Label(image=self.photo)
        self.background.image = self.photo

        # Background image Position
        self.background.place(x=0, y=0)

        # call Main_menu Function
        self.Main_menuFrame()

    def Compare(self):
        """clear the screen and call Scatter class function"""
        self.menuFrame.destroy()
        self.tableFrame.destroy()
        Scatter(self.root, self.data)

    def distribution(self):
        """clear the screen and call Scatter class function"""
        self.menuFrame.destroy()
        self.tableFrame.destroy()
        Require_graph(self.root, self.data)

    def network(self):
        """clear the screen and Call network graph"""
        self.menuFrame.destroy()
        self.tableFrame.destroy()
        Network_graph(self.root, self.data)

    def Main_menuFrame(self):
        """button for user to continue the next function"""
        # title of menu
        self.menuFrame = LabelFrame(self.root,
                                    bg="#C1CDCD")
        self.menuFrame.pack(side=LEFT, padx=50)

        self.manu_frame_title = Label(self.menuFrame,
                                      text="Good place for work!",
                                      font=("Goudy Old Style", 48), bg="white",
                                      fg="#5856a0", padx=10, pady=50, )
        self.manu_frame_title.grid(row=0, padx=10, pady=10,
                                   sticky="w")
        # button for create scatter plot
        self.op1 = Button(self.menuFrame, text="scatter plot",
                          font=("Helvetica", 40), padx=60, pady=10,
                          command=self.Compare)
        self.op1.grid(row=1, column=0, padx=0, pady=10)

        # button to show requirement graph
        self.op2 = Button(self.menuFrame, text="Graph requirement",
                          font=("Helvetica", 40), padx=0, pady=10,
                          command=self.distribution)
        self.op2.grid(row=2, column=0, padx=0, pady=10)

        # button to plot network graph
        self.op3 = Button(self.menuFrame, text="network graph",
                          font=("Helvetica", 40), padx=40, pady=10,
                          command=self.network
                          )
        self.op3.grid(row=3, column=0, padx=0, pady=10)

        # Button to quit tkinter
        self.op4 = Button(self.menuFrame, text="Quit",
                          font=("Helvetica", 40), padx=120, pady=10,
                          command=self.root.quit)
        self.op4.grid(row=4, column=0, padx=0, pady=10)

        # Treeview Frame Configuration
        self.tableFrame = Frame(self.root)
        self.tableFrame.place(x=540, y=40, width=650, height=620)

        # set treeview columns
        self.out = ttk.Treeview(self.tableFrame,
                                columns=(1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
                                height=10,
                                show="headings")
        self.out.place(x=10, y=10, width=630, height=600)

        self.out.heading(1, text="Ranking")
        self.out.heading(2, text="City")
        self.out.heading(3, text="Country")
        self.out.heading(4, text="Average WiFi speed")
        self.out.heading(5, text="Number of co-working spaces")
        self.out.heading(6, text="Average price of buying a coffee")
        self.out.heading(7, text="Average price of taxi (per km)")
        self.out.heading(8, text="Average price for 2 beers in a bar")
        self.out.heading(9, text="bedroom apartment per month")
        self.out.heading(10, text="meal at a local")
        self.out.column(1, width=50)
        self.out.column(2, width=50)
        self.out.column(3, width=50)
        self.out.column(4, width=70)
        self.out.column(5, width=70)
        self.out.column(6, width=70)
        self.out.column(7, width=70)
        self.out.column(8, width=70)
        self.out.column(9, width=70)
        self.out.column(10, width=70)

        # insert data inside treeview
        for i in range(len(self.data)):
            self.out.insert(parent='', index='end', text='',
                            values=(
                                self.data["Ranking"][i], self.data["City"][i],
                                self.data["Country"][i], self.data[
                                    "Average WiFi speed"][
                                    i], self.data[
                                    "Co-working spaces"][
                                    i], self.data[
                                    "Average price of buying a coffee"][
                                    i], self.data[
                                    "Average price of taxi (per km)"][
                                    i], self.data[
                                    "After-work drinks"][
                                    i], self.data[
                                    "bedroom apartment per month"][
                                    i], self.data[
                                    "meal at a local"][
                                    i]
                            ))


class Read_file:
    """Read file form csv"""

    def __init__(self, file_name):
        self.file_name = file_name

    def read(self):
        # Read csv file
        return pd.read_csv(self.file_name)
